/*
*
 ****************************************************************************************
 * @file app_pts_test.h
 * Copyright (C) BEKENCORP 2021
 ****************************************************************************************
 */



#include "uart.h"
#include "user_config.h"
#include "app_pts_test.h"
#if(BQB_TEST_ENABLE == 1)

#include <stdio.h>
#include <string.h>
//#include "uart2.h"
#include "BK_HCI_Protocol.h"

uint8_t local_rx_buf[128];
COMMAND_PACKET *pRxBuf = (COMMAND_PACKET *)(&local_rx_buf[0]);
////HCI_EVENT_PACKET   *pTxBuf = (HCI_EVENT_PACKET *)(&local_tx_buf[0]);
BQB_TEST_COMMAND_PACKET *pTestCmd = (BQB_TEST_COMMAND_PACKET *)(&local_rx_buf[5]);

uint8_t app_pts_bond_req = 0;

void app_pts_set_bond_req(uint8_t val)
{
	app_pts_bond_req = val;
}

uint8_t app_pts_get_bond_req(void)
{
	return app_pts_bond_req;
}

void clear_local_buffer(void)
{
    memset(local_rx_buf, 0, sizeof(local_rx_buf));
}

void app_pts_test_proc(uint8_t cmd,uint8_t length,uint8_t* param)
{
	switch(cmd)
	{
		case APP_BQB_TEST_SM:
			if(param[0] == 0x20)
			{
				extern void app_sec_remove_bond(void);
				app_sec_remove_bond();
			}
			else if(param[0] == 0x21)
			{
				app_pts_set_bond_req(param[1]);
			}
			break;

		case APP_BQB_TEST_BLS:
			if(param[0] == 0)	////PTS BLP/SEN/BPF/BV-06-I
			{
              #if BLE_BP_SENSOR == 1  
				extern void app_blps_set_feature_val(uint16_t val);
				uint16_t tmpVal = (param[2] <<8) + param[1];
				app_blps_set_feature_val(tmpVal);
              #endif
			}
			break;

		case APP_BQB_TEST_GLP:
			if(param[0] == 0)	////PTS GLP/SEN/GLF/BV-06-I, PTS GLP/SEN/GLF/BV-07-I
			{
              #if BLE_GL_SENSOR == 1    
				extern void app_glps_set_feature_val(uint16_t val);
				uint16_t tmpVal = (param[2] <<8) + param[1];
				app_glps_set_feature_val(tmpVal);
              #endif 
			}
			break;

		case APP_BQB_TEST_GLS:
			if(param[0] == 0)	////GLS/SEN/CN/BV-01-C
			{
              #if BLE_GL_SENSOR == 1  
				extern void app_glps_set_feature_val(uint16_t val);
				uint16_t tmpVal = (param[2] <<8) + param[1];
				app_glps_set_feature_val(tmpVal);
              #endif  
			}
			else if(param[0] == 1)	////GLS/SEN/CN/BV-01-C
			{
              #if BLE_GL_SENSOR == 1  
				extern void app_glps_send_data(uint8_t evt_cfg, uint8_t *param);
				app_glps_send_data(param[1], &param[2]);
              #endif  
			}
			else if(param[0] == 2)
			{
              #if BLE_GL_SENSOR == 1  
				extern void app_glps_test_db_init(uint8_t);
				app_glps_test_db_init(param[1]);
              #endif  
			}
			break;

		default:
			break;
	}
}


uint8_t app_pts_test_copy_rx_data(uint8_t *ptr, uint8_t len)
{
	memcpy(local_rx_buf, ptr, len);
	////Check length
	if((pRxBuf->total + 4) < TEST_CMD_HEAD_LENGTH)
	{
		return 1;
	}
	app_pts_test_proc(pRxBuf->cmd,pRxBuf->total,pRxBuf->param);
	return 0;
}
#endif	////(BQB_TEST_ENABLE == 1)
