/**
 ****************************************************************************************
 * @file app_pts_test.h
 * Copyright (C) BEKENCORP 2021
 ****************************************************************************************
 */

#ifndef _APP_PTS_TEST_H_
#define _APP_PTS_TEST_H_
#include "user_config.h"
 #if(BQB_TEST_ENABLE == 1)
 	#include <stdint.h>
	#include "BK_HCI_Protocol.h"

	#define PTS_TESTING_OGF         0x10
    #define TEST_CMD_HEAD_LENGTH	6
	#define BEKEN_OCF               0xE0
	#define COMMAND_HEAD_LENGTH     0x04

	enum {
		////Basic init
		APP_BQB_TEST_INIT			= 0x00,
		////BLE	Protocol
	    APP_BQB_TEST_GAP            = 0x01,
		APP_BQB_TEST_GATT           = 0x02,
		APP_BQB_TEST_L2CAP          = 0x03,
		APP_BQB_TEST_SM             = 0x04,

		////BLE Profile
		APP_BQB_TEST_BAS            = 0x10,
		APP_BQB_TEST_BCS            = 0x11,
		APP_BQB_TEST_BLP            = 0x12,
		APP_BQB_TEST_BLS            = 0x13,
		APP_BQB_TEST_CGMP           = 0x14,
		APP_BQB_TEST_CGMS           = 0x15,
		APP_BQB_TEST_CSCP           = 0x16,
		APP_BQB_TEST_CSCS           = 0x17,
		APP_BQB_TEST_CTS            = 0x18,
		APP_BQB_TEST_DIS            = 0x19,
		APP_BQB_TEST_FTMP           = 0x1A,
		APP_BQB_TEST_FTMS           = 0x1B,
		APP_BQB_TEST_GLP            = 0x1C,
		APP_BQB_TEST_GLS            = 0x1D,
		APP_BQB_TEST_HIDS           = 0x1E,
		APP_BQB_TEST_HOGP           = 0x1F,
		APP_BQB_TEST_HRP            = 0x20,
		APP_BQB_TEST_HRS            = 0x21,
		APP_BQB_TEST_HTP            = 0x22,
		APP_BQB_TEST_HTS            = 0x23,
		APP_BQB_TEST_IAS            = 0x24,
		APP_BQB_TEST_IDP            = 0x25,
		APP_BQB_TEST_IDS            = 0x26,
		APP_BQB_TEST_IPSP           = 0x27,
		APP_BQB_TEST_PLXP           = 0x28,
		APP_BQB_TEST_PLXS			= 0x29,
		APP_BQB_TEST_PXP            = 0x2A,
		APP_BQB_TEST_RSCP           = 0x2B,
		APP_BQB_TEST_RSCS           = 0x2C,
		APP_BQB_TEST_SDP            = 0x2D,
		APP_BQB_TEST_UDS            = 0x2E,
		APP_BQB_TEST_WSP            = 0x2F,
		APP_BQB_TEST_WSS            = 0x30,
	} ;//APP_BQB_TEST_TYPE;

	typedef struct {
	    uint8_t m_func;		////main function index
	    uint8_t s_func;		////2nd function index
	    uint8_t param[];	////parameters
	} __attribute__((packed)) BQB_TEST_COMMAND_PACKET;


	typedef struct {
	    uint8_t code;
	    struct {
	        uint16_t ocf : 10;    /**< OpCode Command Field */
	        uint16_t ogf : 6;     /**< OpCode Group Field */
	    } __attribute__((packed)) opcode;
	    uint8_t total;
	    uint8_t cmd;              /**< private command */
	    uint8_t param[];
	} __attribute__((packed)) COMMAND_PACKET;

	uint8_t app_pts_test_copy_rx_data(uint8_t *ptr, uint8_t len);

 #endif	////(BQB_TEST_ENABLE == 1)
#endif	////_APP_PTS_TEST_H_
